#!/bin/bash
# description: starts cfsetup utility

CFSETUP_HOME=$(cd "$(dirname "$0")"; pwd)
# pointed to by JAVA_HOME

. $CFSETUP_HOME/findjava.sh
RUNTIME_USER=""

#echo "Running with user $RUNTIME_USER"
if [ ! -z "$RUNTIME_USER" -a "$RUNTIME_USER" != "" ]; then
	case `uname` in
		SunOS)
			su $RUNTIME_USER -c "${_JAVACMD}	-Dlog4j1.compatibility=true -Dlog4j.configuration=$CFSETUP_HOME/log4j.properties -DconfigHome=$CFSETUP_HOME -cp  $CFSETUP_HOME/cfsetup.jar:$CFSETUP_HOME/../../cfusion/lib/Saxon-HE-9.8.0-10.jar:$CFSETUP_HOME/../../cfusion/lib/xercesImpl.jar:$CFSETUP_HOME/../../lib/xercesImpl.jar:$CFSETUP_HOME/../../cfusion/lib/commons-lang3-3.4.jar:$CFSETUP_HOME/../../cfusion/lib/log4j.jar:$CFSETUP_HOME/../../cfusion/lib/log4j-api.jar:$CFSETUP_HOME/../../cfusion/lib/log4j-core.jar:$CFSETUP_HOME/../../cfusion/lib/xml-apis.jar:$CFSETUP_HOME/../../cfusion/lib/jansi.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-core.jar:$CFSETUP_HOME/../../cfusion/lib/commons-collections4-4.4.jar:$CFSETUP_HOME/../../cfusion/lib/commons-beanutils-1.9.3.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-annotations.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-databind.jar:$CFSETUP_HOME/../../cfusion/lib/slf4j-log4j12-1.7.12.jar:$CFSETUP_HOME/../../cfusion/lib/slf4j-api-1.7.12.jar:$CFSETUP_HOME/../../cfusion/lib/gson-2.8.6.jar:$CFSETUP_HOME/../../cfusion/lib/pebble.jar:$CFSETUP_HOME/../../cfusion/lib/picocli-4.0.4.jar:$CFSETUP_HOME/../../cfusion/lib/picocli-shell-jline3-4.0.4.jar:$CFSETUP_HOME/../../cfusion/lib/jline-3.13.1.jar:$CFSETUP_HOME/../../cfusion/lib/commons-configuration-1.10.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/commons-collections-3.2.2.jar:$CFSETUP_HOME/../../cfusion/lib/commons-logging.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/commons-lang-2.6.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/xml-apis-1.4.01.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/oro-2.0.8.jar com.adobe.cfsetup.base.EntryPoint $*"
			;;
		Darwin)
			su $RUNTIME_USER -c "${_JAVACMD}	-Dlog4j1.compatibility=true -Dlog4j.configuration=$CFSETUP_HOME/log4j.properties -DconfigHome=$CFSETUP_HOME -cp  $CFSETUP_HOME/cfsetup.jar:$CFSETUP_HOME/../../cfusion/lib/Saxon-HE-9.8.0-10.jar:$CFSETUP_HOME/../../cfusion/lib/xercesImpl.jar:$CFSETUP_HOME/../../lib/xercesImpl.jar:$CFSETUP_HOME/../../cfusion/lib/commons-lang3-3.4.jar:$CFSETUP_HOME/../../cfusion/lib/log4j.jar:$CFSETUP_HOME/../../cfusion/lib/log4j-api.jar:$CFSETUP_HOME/../../cfusion/lib/log4j-core.jar:$CFSETUP_HOME/../../cfusion/lib/xml-apis.jar:$CFSETUP_HOME/../../cfusion/lib/jansi.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-core.jar:$CFSETUP_HOME/../../cfusion/lib/commons-collections4-4.4.jar:$CFSETUP_HOME/../../cfusion/lib/commons-beanutils-1.9.3.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-annotations.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-databind.jar:$CFSETUP_HOME/../../cfusion/lib/slf4j-log4j12-1.7.12.jar:$CFSETUP_HOME/../../cfusion/lib/slf4j-api-1.7.12.jar:$CFSETUP_HOME/../../cfusion/lib/gson-2.8.6.jar:$CFSETUP_HOME/../../cfusion/lib/pebble.jar:$CFSETUP_HOME/../../cfusion/lib/picocli-4.0.4.jar:$CFSETUP_HOME/../../cfusion/lib/picocli-shell-jline3-4.0.4.jar:$CFSETUP_HOME/../../cfusion/lib/jline-3.13.1.jar:$CFSETUP_HOME/../../cfusion/lib/commons-configuration-1.10.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/commons-collections-3.2.2.jar:$CFSETUP_HOME/../../cfusion/lib/commons-logging.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/commons-lang-2.6.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/xml-apis-1.4.01.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/oro-2.0.8.jar com.adobe.cfsetup.base.EntryPoint $*"
			;;
		Linux)
			su -s /bin/sh $RUNTIME_USER -c "${_JAVACMD}	-Dlog4j1.compatibility=true -Dlog4j.configuration=$CFSETUP_HOME/log4j.properties -DconfigHome=$CFSETUP_HOME -cp  $CFSETUP_HOME/cfsetup.jar:$CFSETUP_HOME/../../cfusion/lib/Saxon-HE-9.8.0-10.jar:$CFSETUP_HOME/../../cfusion/lib/xercesImpl.jar:$CFSETUP_HOME/../../lib/xercesImpl.jar:$CFSETUP_HOME/../../cfusion/lib/commons-lang3-3.4.jar:$CFSETUP_HOME/../../cfusion/lib/log4j.jar:$CFSETUP_HOME/../../cfusion/lib/log4j-api.jar:$CFSETUP_HOME/../../cfusion/lib/log4j-core.jar:$CFSETUP_HOME/../../cfusion/lib/xml-apis.jar:$CFSETUP_HOME/../../cfusion/lib/jansi.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-core.jar:$CFSETUP_HOME/../../cfusion/lib/commons-collections4-4.4.jar:$CFSETUP_HOME/../../cfusion/lib/commons-beanutils-1.9.3.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-annotations.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-databind.jar:$CFSETUP_HOME/../../cfusion/lib/slf4j-log4j12-1.7.12.jar:$CFSETUP_HOME/../../cfusion/lib/slf4j-api-1.7.12.jar:$CFSETUP_HOME/../../cfusion/lib/gson-2.8.6.jar:$CFSETUP_HOME/../../cfusion/lib/pebble.jar:$CFSETUP_HOME/../../cfusion/lib/picocli-4.0.4.jar:$CFSETUP_HOME/../../cfusion/lib/picocli-shell-jline3-4.0.4.jar:$CFSETUP_HOME/../../cfusion/lib/jline-3.13.1.jar:$CFSETUP_HOME/../../cfusion/lib/commons-configuration-1.10.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/commons-collections-3.2.2.jar:$CFSETUP_HOME/../../cfusion/lib/commons-logging.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/commons-lang-2.6.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/xml-apis-1.4.01.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/oro-2.0.8.jar com.adobe.cfsetup.base.EntryPoint $*"
			;;
		esac
else
	/bin/sh -c "${_JAVACMD} -Dlog4j1.compatibility=true -Dlog4j.configuration=$CFSETUP_HOME/log4j.properties -DconfigHome=$CFSETUP_HOME -cp  $CFSETUP_HOME/cfsetup.jar:$CFSETUP_HOME/../../cfusion/lib/Saxon-HE-9.8.0-10.jar:$CFSETUP_HOME/../../cfusion/lib/xercesImpl.jar:$CFSETUP_HOME/../../lib/xercesImpl.jar:$CFSETUP_HOME/../../cfusion/lib/commons-lang3-3.4.jar:$CFSETUP_HOME/../../cfusion/lib/log4j.jar:$CFSETUP_HOME/../../cfusion/lib/log4j-api.jar:$CFSETUP_HOME/../../cfusion/lib/log4j-core.jar:$CFSETUP_HOME/../../cfusion/lib/xml-apis.jar:$CFSETUP_HOME/../../cfusion/lib/jansi.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-core.jar:$CFSETUP_HOME/../../cfusion/lib/commons-collections4-4.4.jar:$CFSETUP_HOME/../../cfusion/lib/commons-beanutils-1.9.3.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-annotations.jar:$CFSETUP_HOME/../../cfusion/lib/jackson-databind.jar:$CFSETUP_HOME/../../cfusion/lib/slf4j-log4j12-1.7.12.jar:$CFSETUP_HOME/../../cfusion/lib/slf4j-api-1.7.12.jar:$CFSETUP_HOME/../../cfusion/lib/gson-2.8.6.jar:$CFSETUP_HOME/../../cfusion/lib/pebble.jar:$CFSETUP_HOME/../../cfusion/lib/picocli-4.0.4.jar:$CFSETUP_HOME/../../cfusion/lib/picocli-shell-jline3-4.0.4.jar:$CFSETUP_HOME/../../cfusion/lib/jline-3.13.1.jar:$CFSETUP_HOME/../../cfusion/lib/commons-configuration-1.10.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/commons-collections-3.2.2.jar:$CFSETUP_HOME/../../cfusion/lib/commons-logging.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/commons-lang-2.6.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/xml-apis-1.4.01.jar:$CFSETUP_HOME/../../cfusion/lib/cfsetup-lib/oro-2.0.8.jar com.adobe.cfsetup.base.EntryPoint $*"
fi
STATUS=$?
exit $STATUS
